
%\subsection{An example from M. Beeson}

 The next example is from \cite{beeson::otterLambda}, and is also about rings. 
This example is done in Martin-L\"of type theory, and uses natural numbers.
We define when a ring is {\em integral}.

\begin{code}
-- # import bring
isIntegral : (X:Set) -> (X->X->X) -> X -> Prop
isIntegral X (*) Zero =
  (x:X) -> (y:X) -> Id X (x*y) Zero ==>
		      Id X x Zero \/ Id X y Zero
\end{code}

 Using the data type of natural numbers, we can define the power operation 
and when an element is nilpotent. It is then direct to prove that if $x$ is nilpotent
then $x=0$ in an integral ring.

