{-| This module contains the function to unfold all constants
    except for the FOL constants. It is more or less a call to
    'TypeChecker.Computation.unfoldConstants'. 
-}
module Plugins.FOL.Computation where

import Control.Monad	( zipWithM, mplus )

import Syntax.Internal

import TypeChecker.UnfoldConstants
import TypeChecker.Monad	    ( Definitions )

import Utils.Map
import Utils.Monads
import Utils.Debug

import Plugins.FOL.Constants

-- | Unfold every constant that is not a FOL constant.
--   Very aggresive unfolds inside closures.
unfoldAllButFOLConstants :: Value -> Value
unfoldAllButFOLConstants v = 
    genUnfoldConstants
	    Recursive
	    (\x _ _ -> 
		x `elem`	[ fol_And, fol_Or, fol_Implies, fol_Equiv
				, fol_Not, fol_Equals
				, fol_Prop, fol_True, fol_False
				]
	    )
	    (const Nothing) v

