
module Plugins.Maude where

import Prelude hiding	    ( print, putStr, putStrLn )
import IO.Output

import Control.Monad.Trans

import Syntax.Position
import Syntax.Internal
import Syntax.Values

import TypeChecker.Monad

import Utils.Error

import Plugins

plugin :: SomePlugin
plugin = mkPlugin $ 
    Plugin  { plName		= "maude"
            , plHelp            = help
	    , plInit		= \_ -> return []
	    , plFinal		= solve
	    , plCheck		= check
	    , plInfer		= \_ _ _ _ -> fail "Bad message!"
	    , plOptions		= simpleOptions []
	    , plDefaultOptions	= ()
	    }

type State = [Type]
type Options = ()

help = "MAUDE"

solve :: Options -> State -> TC ()
solve _ s = liftIO $ mapM_ print s

check :: Options -> State -> Range -> [Term] -> Type -> TC (Value, State)
check _ s _ _ t = return (vTop, t : s)

