
-- # import Relation
-- # import Eq

{-
Reflexive' (A : Set) : Relation A -> Relation A -> Prop
Reflexive' (==) (#) = (x, y : A) -> x == y -> x # y

AntiSymmetric' (A : Set) : Relation A -> Relation A -> Prop
AntiSymmetric' (==) (#) = (x, y : A) -> x # y -> y # x -> x == y

Transitive (A : Set) : Relation A -> Prop
Transitive (#) = (x, y, z : A) -> x # y -> y # z -> x # z

TotalOrder' (A : Set) : Relation A -> Relation A -> Type
TotalOrder' E R =
  { !refl     : Reflexive' E R
  ; !antisym  : AntiSymmetric' E R
  ; !trans    : Transitive R
  ; !total    : Total R
  }
-}

Ord : (A : Set) -> Type
Ord A =
  { !leq    : A -> A -> Prop
  ; !equ    : Eq A
  ; !proofs : TotalOrder (decidableRelation equ.eq)
			  leq
  }

reflOrd (A : Set) : (ordA : Ord A) -> Reflexive ordA.leq
reflOrd ordA = \x -> ordA.proofs.refl x x (ordA.equ.proofs.refl x)

