-- Girard's System U^-
-- Author:: Andreas Abel
-- Created:: 2004-12-06
-- Source:: 
-- Coquand/Barthe "Equational Theory of Non-Normalizing PTS" (buggy)
-- Dybjer:: http:://www.cs.chalmers.se/~peterd/kurser/tt03/project.ps 

-- sorts and axioms

Triangle = Set

sort Box : Triangle where
  Pi Triangle Box -> Box

sort Star : Box where
  Pi Box Star -> Star

-- rules 

-- (->) : Star -> Star -> Star -- automatically
-- (->) : Box -> Box -> Box    -- automatically

-- two impredicative universes

-- (->) : Box -> Star -> Star
-- (->) : Triangle -> Box -> Box

-- assumptions
False : Star

-- powerset
P : Box -> Box
P X = X -> Star

not : Star -> Star
not phi = phi -> False

-- Definition of a paradoxical universe

U : Box
U = (X : Box) -> (P (P X) -> X) -> P (P X)

tau : P (P U) -> U
tau t X g p = t (\ x -> p (g (x X g)))

sigma : U -> P (P U)
sigma s = s U tau

rho : U -> U
rho y = tau (sigma y)

-- Intermediate definitions

Q : P (P U)
Q p = (x : U) -> sigma x p -> p x

B : P U
B y = not ((p : P U) -> sigma y p -> p (rho y))

C : U
C = tau Q

D : Star
D = (p : P U) -> Q p -> p C

M : Q B
M x k l = l B k (\ p -> l (\ y -> p (rho y)))

L : not D
L d = d B M (\ p -> d (\ y -> p (rho y)))

R : D
R p h = h C (\ x -> h (rho x))

loop : False
loop = L R

