
-- # import Property

{-

FOL terms are now allowed to contain lambdas.
This is nice when trying to define more general
axioms, like the ones for nat_elim below.

-}

-- Formation
Nat : Set

-- Introduction
zero : Nat
succ : Nat -> Nat

-- Elimination
nat_elim : (C : Nat -> Set)			    ->
	    (z : C zero)			    ->
	    (s : (n : Nat) -> C n -> C (succ n))  ->
	    (n : Nat)				    ->
	    C n

-- Equality
nat_elim_zero :
    (C : Nat -> Set)			    ->
    (z : C zero)			    ->
    (s : (n : Nat) -> C n -> C (succ n))  ->
     (Eq (C zero) (nat_elim C z s zero) z)

nat_elim_succ :
    (C : Nat -> Set)			    ->
    (z : C zero)			    ->
    (s : (n : Nat) -> C n -> C (succ n))  ->
    (n : Nat)				    ->
       (Eq (C (succ n))
		(nat_elim C z s (succ n))
		(s n (nat_elim C z s n))
	    )

-- Addition

add : (n : Nat) -> (m : Nat) -> Nat
add = \n -> nat_elim (\_ -> Nat) n (\_ -> succ)

AddZero : (n:Nat) -> Prop
AddZero = \n -> Eq Nat (add zero n) n

-- Currently broken! gandalf seg faults
-- add_zero_zero :  (AddZero zero)
-- add_zero_zero = fol-plugin (nat_elim_zero (\_ -> Nat), __fol_extensionality)

