-- # import Property

-- some axioms

N : Set

-- (==) = Eq N

(<=) : N -> N -> Prop

data bounded (f:N->N) (n:N) : Prop where
 defBounded : ((x:N) -> f x <= n) -> bounded f n

elimBounded : (f:N->N) -> (n:N) -> bounded f n -> (x:N) -> f x <= n
elimBounded f n (defBounded h) = h

data injective (f:N->N) (n:N) : Prop where
 defInjective : ((x:N) -> (y:N) -> x <= n /\ y <= n /\ f x == f y ==> x == y) -> injective f n

elimInjective : (f:N->N) -> (n:N) -> injective f n ->
                 (x:N) -> (y:N) -> x <= n /\ y <= n /\ f x == f y ==> x == y
elimInjective f n (defInjective h) = h

data image (f:N->N) (n:N) (x:N) : Prop where
 defImage : (y:N) -> y <= n /\ f y == x -> image f n x

introImage : (f:N->N) -> (n:N) -> (x:N) -> (y:N) -> y <= n /\ f y == x ==> image f n x
introImage f n x y h = defImage y h

elimImage : (f:N->N) -> (n:N) -> (x:N) -> image f n x ->
             Exists N (\y -> y <=n /\ f y == x)
elimImage f n x (defImage y h) = fol-plugin(h)

data surjective (f:N->N) (n:N) : Prop where
 defSurjective : ((x:N) -> x <= n ==> image f n x) -> surjective f n

elimSurjective : (f:N->N) -> (n:N) -> surjective f n ->
                  (x:N) -> x <= n ==> image f n x
elimSurjective f n (defSurjective h) = h

One : N

axI : (x:N) -> x <= One ==> x == One

axII : (x:N) -> x <= x

lem1 : (f:N->N) -> (h1:bounded f One) -> surjective f One

lem1 f h1 =
 defSurjective (\ x -> \ h2 -> 
                fol-plugin(elimBounded f One h1,h2,introImage f One,axI,axII))

succ : N -> N

axIII : (x:N) -> (n:N) -> x <= succ n ==> x <= n \/ x == succ n

axIV : (x:N) -> (n:N) -> x <= n ==> Not (x == succ n)

axV : (x:N) -> (n:N) -> x <= n ==> x <= succ n


f : N -> N
n : N
b2 : bounded f (succ n)
i : injective f (succ n)
h1 : f (succ n) == succ n
a : N -> N
ha1 : (k:N) -> f k == succ n ==> a k == n
ha2 : (k:N) -> Not (f k == succ n) ==> a k == f k

lem2 : bounded a n
lem2 = defBounded (\ x -> fol-plugin(elimBounded f (succ n) b2,ha1,ha2,axIII,axII))

lem3 : injective a n
lem3 = defInjective (\ x -> \ y ->
                     fol-plugin(elimInjective f (succ n) i,h1,ha1,ha2,axIV,axV,elimBounded f (succ n) b2,axIII))



